/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.pl.process.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.core.secure.BladeUser;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.secure.utils.AuthUtil;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.core.tool.utils.Func;
import org.springblade.modules.pl.goods.entity.GoodsMaterialEntity;
import org.springblade.modules.pl.goods.vo.GoodsVO;
import org.springblade.modules.pl.process.entity.ProcessItemEntity;
import org.springblade.modules.pl.process.service.IProcessItemService;
import org.springblade.modules.pl.productModel.entity.ProductModelEntity;
import org.springframework.web.bind.annotation.*;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.modules.pl.process.entity.ProcessEntity;
import org.springblade.modules.pl.process.vo.ProcessVO;
import org.springblade.modules.pl.process.excel.ProcessExcel;
import org.springblade.modules.pl.process.wrapper.ProcessWrapper;
import org.springblade.modules.pl.process.service.IProcessService;
import org.springblade.core.boot.ctrl.BladeController;
import org.springblade.core.tool.utils.DateUtil;
import org.springblade.core.excel.util.ExcelUtil;
import org.springblade.core.tool.constant.BladeConstant;
import springfox.documentation.annotations.ApiIgnore;
import java.util.Map;
import java.util.List;
import java.util.Objects;
import javax.servlet.http.HttpServletResponse;

/**
 * 工序表 控制器
 *
 * @author BladeX
 * @since 2024-04-21
 */
@RestController
@AllArgsConstructor
@RequestMapping("pl-process/process")
@Api(value = "工序表", tags = "工序表接口")
public class ProcessController extends BladeController {

	private final IProcessService processService;
	private final IProcessItemService processItemService;

	/**
	 * 工序表 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入process")
	public R<ProcessVO> detail(ProcessEntity process) {
		ProcessEntity detail = processService.getOne(Condition.getQueryWrapper(process));
		ProcessVO processVO = Objects.requireNonNull(BeanUtil.copy(detail, ProcessVO.class));
		List<ProcessItemEntity>details = processItemService.list(Wrappers.<ProcessItemEntity>lambdaUpdate().eq(ProcessItemEntity::getProcessId,detail.getId()));
		processVO.setDetails(details);
		return R.data(processVO);
	}
	/**
	 * 工序表 分页
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入process")
	public R<IPage<ProcessVO>> list(@ApiIgnore @RequestParam Map<String, Object> process, Query query) {
		query.setDescs("create_time");
		BladeUser user = AuthUtil.getUser();
		if(user.getUserCategory()==2){
			process.put("factory_id",user.getFactoryId());
		}
		IPage<ProcessEntity> pages = processService.page(Condition.getPage(query), Condition.getQueryWrapper(process, ProcessEntity.class));
		return R.data(ProcessWrapper.build().pageVO(pages));
	}

	/**
	 * 工序表 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入process")
	public R<IPage<ProcessVO>> page(ProcessVO process, Query query) {
		IPage<ProcessVO> pages = processService.selectProcessPage(Condition.getPage(query), process);
		return R.data(pages);
	}

	/**
	 * 工序表 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入process")
	public R save(@Valid @RequestBody ProcessEntity process) {
		return R.status(processService.save(process));
	}

	/**
	 * 工序表 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入process")
	public R update(@Valid @RequestBody ProcessEntity process) {
		return R.status(processService.updateById(process));
	}

	/**
	 * 工序表 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入process")
	public R submit(@Valid @RequestBody ProcessVO process) {
		return processService.submit(process);
	}

	/**
	 * 工序表 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(processService.deleteLogic(Func.toLongList(ids)));
	}


	/**
	 * 导出数据
	 */
	@GetMapping("/export-process")
	@ApiOperationSupport(order = 9)
	@ApiOperation(value = "导出数据", notes = "传入process")
	public void exportProcess(@ApiIgnore @RequestParam Map<String, Object> process, BladeUser bladeUser, HttpServletResponse response) {
		QueryWrapper<ProcessEntity> queryWrapper = Condition.getQueryWrapper(process, ProcessEntity.class);
		//if (!AuthUtil.isAdministrator()) {
		//	queryWrapper.lambda().eq(Process::getTenantId, bladeUser.getTenantId());
		//}
		queryWrapper.lambda().eq(ProcessEntity::getIsDeleted, BladeConstant.DB_NOT_DELETED);
		List<ProcessExcel> list = processService.exportProcess(queryWrapper);
		ExcelUtil.export(response, "工序表数据" + DateUtil.time(), "工序表数据表", list, ProcessExcel.class);
	}


	/**
	 * 产品型号表 下拉框
	 */
	@GetMapping("/select")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "下拉框", notes = "传入factory")
	public R<List<ProcessEntity>> select(ProcessEntity process, Query query) {
		BladeUser user = AuthUtil.getUser();
		if(user.getUserCategory()==2){
			process.setFactoryId(user.getFactoryId());
		}
		List<ProcessEntity> list = processService.list(Condition.getQueryWrapper(process));
		return R.data(list);
	}
}
